//-----------------------------------------------------------------------------
// Title:   Technical Training Organization (TTO) BIOS Workshop 5.92
// File:	isr.c 
// Rev:		1.5
// Date:	06-10-2011
// Author:	Eric Wilbur (ericw@ti.com)
// Ref:		C6748 BSL, Experimenter Test Example (audio, mcasp)
// Notes:	1. Refer to main.h for key definitions
//			2. Refer to .tcf (INT5) properties for more info
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "main.h"
#include "clk.h"
#include <math.h>


//-----------------------------------------------------------------------------
// isrAudio()
//-----------------------------------------------------------------------------




void isrAudio(void)
{

// Create your infinite while loop here	

}

void WriteSample(float left,float right)
{
      
	  int32_t ileft  = (int32_t) left;
      int32_t iright = (int32_t)right;
	  int32_t dataOut32;

    /* Combine ileft and iright into a 32-bit word */
      dataOut32 = (iright << 16) | (ileft & 0x0000ffff);
      
     while(!CHKBIT(MCASP->SRCTL11, XRDY)){} // For polling the infinite while loop goes on checking continuously the status of the XRDY bit
     MCASP->XBUF11 = dataOut32;   
}

void ReadSample( float *left, float *right)
{
	  Int32 input;
      Int32 ileft;
      Int32 iright;
	  
      /* Poll the ready flag of the serial port
	 and return true/false to indicate success. */
      while(!CHKBIT(MCASP->SRCTL12, RRDY)){};
      input = MCASP->XBUF12;

	  iright=  input >> 16;
	  ileft = (input << 16) >> 16;

	  *left  = (float) ileft;
	  *right = (float) iright;
}



