//-----------------------------------------------------------------------------
// Title:   Technical Training Organization (TTO) BIOS Workshop 5.50
// File:	main.h 
// Rev:		1.0
// Date:	08-31-2010
// Author:	Eric Wilbur (ericw@ti.com)
// Ref:		C6748 BSL, Experimenter Test Example (audio, mcasp)
//
// Brief:	Definitions, prototypes and externs
//
// Notes:	1. Refer to main.h for key definitions
//			2. If NO GEL file present, uncomment #define in main.h
//-----------------------------------------------------------------------------
#ifndef MAIN_H_
#define MAIN_H_

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "sine_wavecfg.h"			//BIOS include file
#include "types.h"
#include "stdio.h"
#include "evmc6748.h"
#include "evmc6748_timer.h"
#include "evmc6748_gpio.h"
#include "evmc6748_i2c.h"
#include "evmc6748_mcasp.h"
#include "evmc6748_aic3106.h"
#include <clk.h>


//-----------------------------------------------------------------------------
// Definitions - BUFFSIZE, PING/PONG, FILTER ORDER
//-----------------------------------------------------------------------------
#define BUFFSIZE 64
#define PING     0
#define PONG     1
//#define ORDER    64

// #define NO_GEL    (1)			// uncomment if no GEL file initialization


//-----------------------------------------------------------------------------
// Prototypes
//-----------------------------------------------------------------------------

void FIR_process(int16_t * Src, int16_t * Dst, uint16_t len);
//void FIR_process(void);
void isrAudio(void);
void McASP_Init_TTO();								// init McASP
void AIC3106_Init_TTO();								// init AIC3106
void McASP_Start_TTO();
void USTIMER_delay(uint32_t time);
void WriteSample(float left,float right);
void ReadSample( float *left, float *right)

#endif



